/*
 * This file was automaticly generated by clo++ version 0.6.4 (REL-0_6_4)
 * http://pmade.org/pjones/software/clo++/
 */

/** @file
 * This file contains the implementation of the parser class.
 * You can control the name of this source file using the
 * cxx_source_file variable.
**/

#include "Options.h"
#include <cstring>
#include <cstdlib>
#include <cctype>

namespace {
    const char const_usage[] =
"  -B, --byte enum            Represent byte as string or number.\n"
"  -C, --vcolumn string       FITS table column name to exclude from output.\n"
"  -F, --falsevalue string    String representing false for FITS logical\n"
"                             type.\n"
"  -I, --invalidvalue string  String representing invalid for FITS logical\n"
"                             type.\n"
"  -R, --rvcolumn string      Regular expression for column names to exclude\n"
"                             from output.\n"
"  -T, --truevalue string     String representing true for FITS logical type.\n"
"  -V, --verbose              Print warnings about column matches that fail.\n"
"  -a, --arraysep string      Seperator used when printing array fields.\n"
"  -c, --column string        FITS table column name to include in output.\n"
"  -d, --defformat string     Default type output format definition\n"
"  -e, --extname string       FITS extension name to search for.\n"
"  -f, --colformat string     Column specific output format definition\n"
"  -i, --input string         Input FITS file name.\n"
"  -m, --comment              Prints FITS HDU cards as RDB comments.\n"
"  -n, --extnum int           FITS extension number to search for.\n"
"  -o, --output string        Output RDB file name.\n"
"  -r, --rcolumn string       Regular expression for column names to include\n"
"                             in output.\n"
"  -t, --trim bool            Trim/Do not trim leading and trailing\n"
"                             whitespace from RDB comments and table string\n"
"                             fields.\n"
"  -u, --usage                Print detailed usage information.\n"
"  -v, --version              Print version information, then exit.\n"
"  -x, --maxrow int           Maximum number of rows to read at a time.\n";

    const char const_help_comment[] =
"use the --help option for help";

    const char* expand_long_name (const std::string &name);
}

//#########################################################################
clo::parser::parser (void)
    : state_(state_option)
{
    std::memset(&locations_, 0, sizeof(locations_));
}
//#########################################################################
void clo::parser::parse (int argc, char *argv[], bool call_finalize) {
    for (int i=1; i<argc; ++i) parse_element(argv[i], i, source_cl);
    if (call_finalize) finalize();
}
//#########################################################################
void clo::parser::finalize (void) {
    if (state_ == state_value) {
	switch (openum_) {
	    case option_arraysep:
		throw option_error("missing value for 'arraysep' option");
	    case option_byterep:
		throw option_error("missing value for 'byte' option");
	    case option_colformat:
		throw option_error("missing value for 'colformat' option");
	    case option_column:
		throw option_error("missing value for 'column' option");
	    case option_comment:
		throw option_error("missing value for 'comment' option");
	    case option_defformat:
		throw option_error("missing value for 'defformat' option");
	    case option_extname:
		throw option_error("missing value for 'extname' option");
	    case option_extnum:
		throw option_error("missing value for 'extnum' option");
	    case option_falsevalue:
		throw option_error("missing value for 'falsevalue' option");
	    case option_input:
		throw option_error("missing value for 'input' option");
	    case option_invalidvalue:
		throw option_error("missing value for 'invalidvalue' option");
	    case option_maxrow:
		throw option_error("missing value for 'maxrow' option");
	    case option_output:
		throw option_error("missing value for 'output' option");
	    case option_rcolumn:
		throw option_error("missing value for 'rcolumn' option");
	    case option_rvcolumn:
		throw option_error("missing value for 'rvcolumn' option");
	    case option_trim:
		throw option_error("missing value for 'trim' option");
	    case option_truevalue:
		throw option_error("missing value for 'truevalue' option");
	    case option_usage:
		throw option_error("missing value for 'usage' option");
	    case option_vcolumn:
		throw option_error("missing value for 'vcolumn' option");
	    case option_verbose:
		throw option_error("missing value for 'verbose' option");
	    case option_version:
		throw option_error("missing value for 'version' option");
	}

    }

}
//#########################################################################
void clo::parser::parse_element (const char *element, int position, opsource source) {
    std::size_t length = std::strlen(element);

    switch (state_) {
	case state_consume:
	    non_options_.push_back(element);
	    break;
	case state_option:
	    if (length >= 2 && element[0] == '-' && element[1] == '-') {
		if (length == 2) { state_ = state_consume; return; }
		element += 2;
		const char *value = element;
		while (*value != 0 && *value != '=') ++value;
		if (*value == '=') {
		    std::string selement(element, value - element), svalue(++value);

		    parse_long_option(selement.c_str(), position, source);
		    if (state_ != state_value) {
			std::string error("the '"); error += element; error += "' option does not take a value";
			throw option_error(error);
		    }

		    parse_value(svalue.c_str());
		    state_ = state_option;
		} else {
		    parse_long_option(element, position, source);
		}
	    } else if (length >= 2 && element[0] == '-') {
		++element;

		if (length > 2) {
		    while (*element != 0) {
			parse_short_option(*element, position, source);
			++element;
	    
			if (state_ == state_value && *element != 0) {
			    parse_value(element);
			    state_ = state_option;
			    break;
			}
		    }
		} else {
		    parse_short_option(*element, position, source);
		}
	    } else {
		non_options_.push_back(element);
	    }
	    break;
	case state_value:
	    parse_value(element);
	    state_ = state_option;
	    break;
    }
}
//#########################################################################
void clo::parser::parse_short_option (char option, int position, opsource source) {
    switch (option) {
    	case 'B':
    	    source = source; // kill compiler unused variable warning
    	    openum_ = option_byterep;
    	    state_ = state_value;
    	    locations_.byterep = position;
    	    return;
    	case 'C':
    	    source = source; // kill compiler unused variable warning
    	    openum_ = option_vcolumn;
    	    state_ = state_value;
    	    locations_.vcolumn = position;
    	    return;
    	case 'F':
    	    source = source; // kill compiler unused variable warning
    	    openum_ = option_falsevalue;
    	    state_ = state_value;
    	    locations_.falsevalue = position;
    	    return;
    	case 'I':
    	    source = source; // kill compiler unused variable warning
    	    openum_ = option_invalidvalue;
    	    state_ = state_value;
    	    locations_.invalidvalue = position;
    	    return;
    	case 'R':
    	    source = source; // kill compiler unused variable warning
    	    openum_ = option_rvcolumn;
    	    state_ = state_value;
    	    locations_.rvcolumn = position;
    	    return;
    	case 'T':
    	    source = source; // kill compiler unused variable warning
    	    openum_ = option_truevalue;
    	    state_ = state_value;
    	    locations_.truevalue = position;
    	    return;
    	case 'V':
    	    source = source; // kill compiler unused variable warning
    	    openum_ = option_verbose;
    	    options_.verbose = !options_.verbose;
    	    locations_.verbose = position;
    	    return;
    	case 'a':
    	    source = source; // kill compiler unused variable warning
    	    openum_ = option_arraysep;
    	    state_ = state_value;
    	    locations_.arraysep = position;
    	    return;
    	case 'c':
    	    source = source; // kill compiler unused variable warning
    	    openum_ = option_column;
    	    state_ = state_value;
    	    locations_.column = position;
    	    return;
    	case 'd':
    	    source = source; // kill compiler unused variable warning
    	    openum_ = option_defformat;
    	    state_ = state_value;
    	    locations_.defformat = position;
    	    return;
    	case 'e':
    	    source = source; // kill compiler unused variable warning
    	    openum_ = option_extname;
    	    state_ = state_value;
    	    locations_.extname = position;
    	    return;
    	case 'f':
    	    source = source; // kill compiler unused variable warning
    	    openum_ = option_colformat;
    	    state_ = state_value;
    	    locations_.colformat = position;
    	    return;
    	case 'i':
    	    source = source; // kill compiler unused variable warning
    	    openum_ = option_input;
    	    state_ = state_value;
    	    locations_.input = position;
    	    return;
    	case 'm':
    	    source = source; // kill compiler unused variable warning
    	    openum_ = option_comment;
    	    options_.comment = !options_.comment;
    	    locations_.comment = position;
    	    return;
    	case 'n':
    	    source = source; // kill compiler unused variable warning
    	    openum_ = option_extnum;
    	    state_ = state_value;
    	    locations_.extnum = position;
    	    return;
    	case 'o':
    	    source = source; // kill compiler unused variable warning
    	    openum_ = option_output;
    	    state_ = state_value;
    	    locations_.output = position;
    	    return;
    	case 'r':
    	    source = source; // kill compiler unused variable warning
    	    openum_ = option_rcolumn;
    	    state_ = state_value;
    	    locations_.rcolumn = position;
    	    return;
    	case 't':
    	    source = source; // kill compiler unused variable warning
    	    openum_ = option_trim;
    	    state_ = state_value;
    	    locations_.trim = position;
    	    return;
    	case 'u':
    	    source = source; // kill compiler unused variable warning
    	    throw autoexcept(autothrow_usage, "usage");
    	case 'v':
    	    source = source; // kill compiler unused variable warning
    	    throw autoexcept(autothrow_version, "version");
    	case 'x':
    	    source = source; // kill compiler unused variable warning
    	    openum_ = option_maxrow;
    	    state_ = state_value;
    	    locations_.maxrow = position;
    	    return;
    	case 'h':
    	    if (source != source_cl) break;
    	    throw autoexcept(autothrow_help, const_usage);
    	case '?':
    	    if (source != source_cl) break;
    	    throw autoexcept(autothrow_help, const_usage);
    }

    std::string error("unknown option: '"); error += option; error += "'";
    throw option_error(error);
}
//#########################################################################
void clo::parser::parse_long_option (const char *option, int position, opsource source) {
    option = expand_long_name(option);

	    if (std::strcmp(option, "arraysep") == 0) {
		source = source; // kill compiler unused variable warning
		openum_ = option_arraysep;
		locations_.arraysep = position;
		state_ = state_value;
		return;
	    } else if (std::strcmp(option, "byte") == 0) {
		source = source; // kill compiler unused variable warning
		openum_ = option_byterep;
		locations_.byterep = position;
		state_ = state_value;
		return;
	    } else if (std::strcmp(option, "colformat") == 0) {
		source = source; // kill compiler unused variable warning
		openum_ = option_colformat;
		locations_.colformat = position;
		state_ = state_value;
		return;
	    } else if (std::strcmp(option, "column") == 0) {
		source = source; // kill compiler unused variable warning
		openum_ = option_column;
		locations_.column = position;
		state_ = state_value;
		return;
	    } else if (std::strcmp(option, "comment") == 0) {
		source = source; // kill compiler unused variable warning
		openum_ = option_comment;
		locations_.comment = position;
		options_.comment = !options_.comment;
		return;
	    } else if (std::strcmp(option, "defformat") == 0) {
		source = source; // kill compiler unused variable warning
		openum_ = option_defformat;
		locations_.defformat = position;
		state_ = state_value;
		return;
	    } else if (std::strcmp(option, "extname") == 0) {
		source = source; // kill compiler unused variable warning
		openum_ = option_extname;
		locations_.extname = position;
		state_ = state_value;
		return;
	    } else if (std::strcmp(option, "extnum") == 0) {
		source = source; // kill compiler unused variable warning
		openum_ = option_extnum;
		locations_.extnum = position;
		state_ = state_value;
		return;
	    } else if (std::strcmp(option, "falsevalue") == 0) {
		source = source; // kill compiler unused variable warning
		openum_ = option_falsevalue;
		locations_.falsevalue = position;
		state_ = state_value;
		return;
	    } else if (std::strcmp(option, "input") == 0) {
		source = source; // kill compiler unused variable warning
		openum_ = option_input;
		locations_.input = position;
		state_ = state_value;
		return;
	    } else if (std::strcmp(option, "invalidvalue") == 0) {
		source = source; // kill compiler unused variable warning
		openum_ = option_invalidvalue;
		locations_.invalidvalue = position;
		state_ = state_value;
		return;
	    } else if (std::strcmp(option, "maxrow") == 0) {
		source = source; // kill compiler unused variable warning
		openum_ = option_maxrow;
		locations_.maxrow = position;
		state_ = state_value;
		return;
	    } else if (std::strcmp(option, "output") == 0) {
		source = source; // kill compiler unused variable warning
		openum_ = option_output;
		locations_.output = position;
		state_ = state_value;
		return;
	    } else if (std::strcmp(option, "rcolumn") == 0) {
		source = source; // kill compiler unused variable warning
		openum_ = option_rcolumn;
		locations_.rcolumn = position;
		state_ = state_value;
		return;
	    } else if (std::strcmp(option, "rvcolumn") == 0) {
		source = source; // kill compiler unused variable warning
		openum_ = option_rvcolumn;
		locations_.rvcolumn = position;
		state_ = state_value;
		return;
	    } else if (std::strcmp(option, "trim") == 0) {
		source = source; // kill compiler unused variable warning
		openum_ = option_trim;
		locations_.trim = position;
		state_ = state_value;
		return;
	    } else if (std::strcmp(option, "truevalue") == 0) {
		source = source; // kill compiler unused variable warning
		openum_ = option_truevalue;
		locations_.truevalue = position;
		state_ = state_value;
		return;
	    } else if (std::strcmp(option, "usage") == 0) {
		source = source; // kill compiler unused variable warning
		throw autoexcept(autothrow_usage, "usage");
	    } else if (std::strcmp(option, "vcolumn") == 0) {
		source = source; // kill compiler unused variable warning
		openum_ = option_vcolumn;
		locations_.vcolumn = position;
		state_ = state_value;
		return;
	    } else if (std::strcmp(option, "verbose") == 0) {
		source = source; // kill compiler unused variable warning
		openum_ = option_verbose;
		locations_.verbose = position;
		options_.verbose = !options_.verbose;
		return;
	    } else if (std::strcmp(option, "version") == 0) {
		source = source; // kill compiler unused variable warning
		throw autoexcept(autothrow_version, "version");
	    } else if (source == source_cl && std::strcmp(option, "help") == 0) {
		throw autoexcept(autothrow_help, const_usage);
	    }

    std::string error("unknown option '"); error += option; error += "'";
    throw option_error(error);
}
//#########################################################################
void clo::parser::parse_value (const char *value) {
    switch (openum_) {
    	case option_arraysep:
    	    {
    		options_.arraysep = value;
    	    }
    	    break;
    	case option_byterep:
    	    {
    		byterep_enum evalue;

    		if (std::strcmp(value, "num") == 0) {
    		    evalue = byterep_num;
    		} else if (std::strcmp(value, "str") == 0) {
    		    evalue = byterep_str;
    		} else {
    		    std::string error("'"); error += value; error += "' is an invalid value for the 'byte' option";
    		    throw option_error(error);
    		}

    		options_.byterep = evalue;
    	    }
    	    break;
    	case option_colformat:
    	    {
    		std::string svalue(value); std::string::size_type eqpos = svalue.find('=');
    		if (eqpos == std::string::npos) { 
    		    throw option_error("invalid key=value pair for the 'colformat' option");
    		}
    
    		std::string k(svalue.substr(0, eqpos)), v(svalue.substr(eqpos+1));
    		value = v.c_str();

    		options_.colformat[k] = v;
    	    }
    	    break;
    	case option_column:
    	    {
    		options_.column.push_back(value);
    	    }
    	    break;
    	case option_comment:
    	    break;
    	case option_defformat:
    	    {
    		std::string svalue(value); std::string::size_type eqpos = svalue.find('=');
    		if (eqpos == std::string::npos) { 
    		    throw option_error("invalid key=value pair for the 'defformat' option");
    		}
    
    		std::string k(svalue.substr(0, eqpos)), v(svalue.substr(eqpos+1));
    		value = v.c_str();

    		options_.defformat[k] = v;
    	    }
    	    break;
    	case option_extname:
    	    {
    		options_.extname = value;
    	    }
    	    break;
    	case option_extnum:
    	    {
    		char *endptr; int tmp = std::strtol(value, &endptr, 0);
    		while (*endptr != 0 && std::isspace(*endptr)) ++endptr;

    		if (*endptr != 0) {
    		    std::string error("invalid integer value '"); error += value; error += "'";
    		    throw option_error(error);
    		}

    		options_.extnum = tmp;
    	    }
    	    break;
    	case option_falsevalue:
    	    {
    		options_.falsevalue = value;
    	    }
    	    break;
    	case option_input:
    	    {
    		options_.input = value;
    	    }
    	    break;
    	case option_invalidvalue:
    	    {
    		options_.invalidvalue = value;
    	    }
    	    break;
    	case option_maxrow:
    	    {
    		char *endptr; int tmp = std::strtol(value, &endptr, 0);
    		while (*endptr != 0 && std::isspace(*endptr)) ++endptr;

    		if (*endptr != 0) {
    		    std::string error("invalid integer value '"); error += value; error += "'";
    		    throw option_error(error);
    		}

    		options_.maxrow = tmp;
    	    }
    	    break;
    	case option_output:
    	    {
    		options_.output = value;
    	    }
    	    break;
    	case option_rcolumn:
    	    {
    		options_.rcolumn.push_back(value);
    	    }
    	    break;
    	case option_rvcolumn:
    	    {
    		options_.rvcolumn.push_back(value);
    	    }
    	    break;
    	case option_trim:
    	    {
    		bool bvalue;

    		if (std::strcmp(value, "true") == 0) {
    		    bvalue = true;
    		} else if (std::strcmp(value, "yes") == 0) {
    		    bvalue = true;
    		} else if (std::strcmp(value, "false") == 0) {
    		    bvalue = false;
    		} else if (std::strcmp(value, "no") == 0) {
    		    bvalue = false;
    		} else {
    		    std::string error("invalid boolean value '"); error += value; error += "'";
    		    throw option_error(error);
    		}
    		options_.trim = bvalue;
    	    }
    	    break;
    	case option_truevalue:
    	    {
    		options_.truevalue = value;
    	    }
    	    break;
    	case option_usage:
    	    break;
    	case option_vcolumn:
    	    {
    		options_.vcolumn.push_back(value);
    	    }
    	    break;
    	case option_verbose:
    	    break;
    	case option_version:
    	    break;
    }
}
//#########################################################################
const char* clo::option_error::get_help_comment (void) const {
    return const_help_comment;
}
//#########################################################################
namespace {
    const char* expand_long_name (const std::string &name) {
	std::string::size_type name_size = name.size();
	std::vector<const char*> matches;

        if (name_size <= 8 && name.compare(0, name_size, "arraysep", name_size) == 0)
        	matches.push_back("arraysep");

        if (name_size <= 4 && name.compare(0, name_size, "byte", name_size) == 0)
        	matches.push_back("byte");

        if (name_size <= 9 && name.compare(0, name_size, "colformat", name_size) == 0)
        	matches.push_back("colformat");

        if (name_size <= 6 && name.compare(0, name_size, "column", name_size) == 0)
        	matches.push_back("column");

        if (name_size <= 7 && name.compare(0, name_size, "comment", name_size) == 0)
        	matches.push_back("comment");

        if (name_size <= 9 && name.compare(0, name_size, "defformat", name_size) == 0)
        	matches.push_back("defformat");

        if (name_size <= 7 && name.compare(0, name_size, "extname", name_size) == 0)
        	matches.push_back("extname");

        if (name_size <= 6 && name.compare(0, name_size, "extnum", name_size) == 0)
        	matches.push_back("extnum");

        if (name_size <= 10 && name.compare(0, name_size, "falsevalue", name_size) == 0)
        	matches.push_back("falsevalue");

        if (name_size <= 5 && name.compare(0, name_size, "input", name_size) == 0)
        	matches.push_back("input");

        if (name_size <= 12 && name.compare(0, name_size, "invalidvalue", name_size) == 0)
        	matches.push_back("invalidvalue");

        if (name_size <= 6 && name.compare(0, name_size, "maxrow", name_size) == 0)
        	matches.push_back("maxrow");

        if (name_size <= 6 && name.compare(0, name_size, "output", name_size) == 0)
        	matches.push_back("output");

        if (name_size <= 7 && name.compare(0, name_size, "rcolumn", name_size) == 0)
        	matches.push_back("rcolumn");

        if (name_size <= 8 && name.compare(0, name_size, "rvcolumn", name_size) == 0)
        	matches.push_back("rvcolumn");

        if (name_size <= 4 && name.compare(0, name_size, "trim", name_size) == 0)
        	matches.push_back("trim");

        if (name_size <= 9 && name.compare(0, name_size, "truevalue", name_size) == 0)
        	matches.push_back("truevalue");

        if (name_size <= 5 && name.compare(0, name_size, "usage", name_size) == 0)
        	matches.push_back("usage");

        if (name_size <= 7 && name.compare(0, name_size, "vcolumn", name_size) == 0)
        	matches.push_back("vcolumn");

        if (name_size <= 7 && name.compare(0, name_size, "verbose", name_size) == 0)
        	matches.push_back("verbose");

        if (name_size <= 7 && name.compare(0, name_size, "version", name_size) == 0)
        	matches.push_back("version");

        if (name_size <= 4 && name.compare(0, name_size, "help", name_size) == 0)
        	matches.push_back("help");


	if (matches.empty()) {
	    std::string error("unknown option '"); error += name; error += "'";
	    throw clo::option_error(error);
	}

	if (matches.size() == 1) {
	    return matches[0];
	}

	std::string error("the option name '"); error += name; error += "' is ambiguous";
	throw clo::option_error(error);
    }
} // end anonymous namespace
