/*
 * This file was automaticly generated by clo++ version 0.6.4 (REL-0_6_4)
 * http://pmade.org/pjones/software/clo++/
 */

/** @file
 * This is the main header file (Options.h).
 * You can control the name of this header file using the
 * cxx_header_file variable.
**/

// you can control the include guard
// name with the cxx_header_def variable
#ifndef __Option__h__
#define __Option__h__


// standard includes
#include <stdexcept>
#include <string>
#include <vector>
#include <map>

/// the namespace can be controlled using the cxx_namespace variable
namespace clo {
    /**
     * a list of autothrow ids for the autoexcept exception class
     * so that you know which option caused the exception.
    **/
    enum autothrow { 
	autothrow_help,
	autothrow_version,
	autothrow_usage
    };

    enum byterep_enum {
	byterep_num,
	byterep_str
    };

    /**
     * the following struct is used to hold the values of
     * the options. It has a constructor that sets all the option 
     * values to their default value.
    **/
    struct options {
	options (void) :
	    arraysep(","),
	    byterep(byterep_str),
	    comment(false),
	    extnum(-1),
	    falsevalue("F"),
	    input("stdin"),
	    maxrow(8192),
	    output("stdout"),
	    trim(true),
	    truevalue("T"),
	    usage(false),
	    verbose(false),
	    version(false)
	{ }

	std::string arraysep;
	byterep_enum byterep;
	std::map<std::string, std::string> colformat;
	std::vector<std::string> column;
	bool comment;
	std::map<std::string, std::string> defformat;
	std::string extname;
	int extnum;
	std::string falsevalue;
	std::string input;
	std::string invalidvalue;
	int maxrow;
	std::string output;
	std::vector<std::string> rcolumn;
	std::vector<std::string> rvcolumn;
	bool trim;
	std::string truevalue;
	bool usage;
	std::vector<std::string> vcolumn;
	bool verbose;
	bool version;
    }; // end options struct
 
    /**
     * the following struct is used to record the location
     * on the command line where the option was found.
    **/
    struct option_locations {
	typedef int size_type;
	size_type arraysep;
	size_type byterep;
	size_type colformat;
	size_type column;
	size_type comment;
	size_type defformat;
	size_type extname;
	size_type extnum;
	size_type falsevalue;
	size_type input;
	size_type invalidvalue;
	size_type maxrow;
	size_type output;
	size_type rcolumn;
	size_type rvcolumn;
	size_type trim;
	size_type truevalue;
	size_type usage;
	size_type vcolumn;
	size_type verbose;
	size_type version;
    }; // end option location struct

    /**
     * if there are any errors while parsing the command
     * line, the following class will be thrown.
    **/
    class option_error : public std::runtime_error {
    public:
	option_error (const std::string &what_arg)
	    : runtime_error(what_arg) { }
	
	const char* get_help_comment (void) const;
    };

    /**
     * if any option that is a autothrow option is present
     * on the command line, this exception class will be
     * thrown when that option is parsed.
    **/
    class autoexcept : public option_error {
    public:
	// constructor
	autoexcept (autothrow id, const std::string &message)
	    : option_error(message), autothrow_(id) { }
    
	/**
	 * get the autothrow enum member for the autothrow
	 * option that caused the exception.
	**/
	autothrow get_autothrow_id (void) const
	{ return autothrow_; }
    private:
	autothrow autothrow_;
    };

    /**
     * the parser class is the main command
     * line parsing class. You can control the name of it
     * using the cxx_class variable.
    **/
    class parser {
    public:
	/// default constructor
	parser (void);
    
	/// parse the command line
	void parse(int argc, char *argv[], bool call_finalize=true);

	/// finalize all parsing (eg. check for mandatory options)
	void finalize (void);

	/// get a list of nonoptions from the command line
	const std::vector<std::string>& get_non_options (void) const
	{ return non_options_; }

	/// get the main options
	const options& get_options (void) const
	{ return options_; }

	/// get the main option locations
	const option_locations& get_locations (void) const
	{ return locations_; }
    private:
	options options_;
	option_locations locations_;

	enum options_enum {
	    option_version,
		option_input,
		option_output,
		option_extname,
		option_extnum,
		option_column,
		option_rcolumn,
		option_vcolumn,
		option_rvcolumn,
		option_arraysep,
		option_comment,
		option_trim,
		option_truevalue,
		option_falsevalue,
		option_invalidvalue,
		option_byterep,
		option_maxrow,
		option_colformat,
		option_defformat,
		option_verbose,
		option_usage
	} openum_;

	enum parser_state { state_option, state_value, state_consume } state_;
	std::vector<std::string> non_options_;

	enum opsource { source_cl, source_cf };
	void parse_element      (const char *element, int position, opsource source);
	void parse_short_option (char option, int position, opsource source);
	void parse_long_option  (const char *option, int position, opsource source);
	void parse_value        (const char *value);
    }; // end clo::parser class
} // end clo namespace
#endif
